import des from '../venders/3des';
import { DES } from '../../env'; // tslint:disable-line
var Key = DES.Key, Iv = DES.Iv;
var Des = /** @class */ (function () {
    /**
     * [constructor description]
     * @param  {[type]} key [description]
     * @param  {[type]} iv  [description]
     * @return {[type]}     [description]
     */
    function Des(key, iv) {
        if (!key || !iv) {
            throw new Error('no key or no iv');
        }
        Des.iv = iv;
        Des.key = Des.genKey(key);
    }
    /**
     * [genKey description]
     * @param  {[type]} key [description]
     * @return {[type]}     [description]
     */
    Des.genKey = function (key) {
        for (var i = key.length; i < 24; i++) {
            key += "0";
        }
        // log(key, key)
        // key.padEnd(24,'0')
        return key.slice(0, 24);
    };
    /**
     * [encrypt description]
     * @param  {[type]} input [description]
     * @return {[type]}       [description]
     */
    Des.prototype.encrypt = function (input) {
        // log(Des.des)
        // des(key, message, encrypt, mode, iv, padding)
        return btoa(des(Des.key, input, 1, 1, Des.iv, 1));
    };
    /**
     * [decrypt description]
     * @param  {[type]} input [description]
     * @return {[type]}       [description]
     */
    Des.prototype.decrypt = function (input) {
        try {
            atob(unescape(input));
            return des(Des.key, atob(unescape(input)), 0, 1, Des.iv, 1);
        }
        catch (e) {
            // log(e)
            return '';
        }
    };
    return Des;
}());
export { Des };
var OriginDes = new Des(Key, Iv);
// export default new Des(Key, Iv);
// import { DES } from '../../env'; // tslint:disable-line
import CryptoJS from 'crypto-js';
import tripledes from 'crypto-js/tripledes';
var IV = CryptoJS.enc.Utf8.parse(DES.Iv);
var KEY = CryptoJS.enc.Utf8.parse(DES.Key);
/**
 * 使用Crypto.js加解密（DES）
 * 张浩祺 2018-03-01
 * @class CryptoDES
 */
var CryptoDES = /** @class */ (function () {
    function CryptoDES() {
    }
    CryptoDES.prototype.encrypt = function (message) {
        var result = '';
        if (message) {
            result = encodeURIComponent(tripledes.encrypt(message, KEY, {
                iv: IV,
                mode: CryptoJS.mode.CBC,
                padding: CryptoJS.pad.Pkcs7
            }));
        }
        return decodeURIComponent(result);
    };
    CryptoDES.prototype.decrypt = function (message) {
        var result = '';
        if (message) {
            message = decodeURIComponent(message);
            result = tripledes.decrypt({ ciphertext: CryptoJS.enc.Base64.parse(message) }, KEY, {
                iv: IV, mode: CryptoJS.mode.CBC, padding: CryptoJS.pad.Pkcs7
            });
        }
        return result ? result.toString(CryptoJS.enc.Utf8) : result;
    };
    return CryptoDES;
}());
export default new CryptoDES();
